--******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

SET CURRENT SCHEMA = CONFIG;

CREATE TABLE ETL_INFO
(ETL_ID VARCHAR(36) NOT NULL,
	START_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL ,
	END_DATETIME TIMESTAMP,
	STATUS INTEGER,
	DATASOURCE_ID VARCHAR(36) NOT NULL,
	LOAD_TYPE CHAR(1) DEFAULT 'D' NOT NULL)
;

CREATE TABLE SYSCONFIG_INFO
 (INFO_ID INTEGER NOT NULL,
 NAME VARCHAR(100) NOT NULL,
 DISPLAY_NAME VARCHAR(100),
 INT_VALUE INTEGER,
 CHAR_VALUE VARCHAR(100),
 REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL)
;

ALTER TABLE ETL_INFO ADD CONSTRAINT ETLINF_PK PRIMARY KEY (ETL_ID);
ALTER TABLE SYSCONFIG_INFO ADD CONSTRAINT SYSCFG_PK PRIMARY KEY (INFO_ID);

CREATE TABLE EXTERNAL_MAPPING
(MSTERSHIP_SOURCE_ID VARCHAR(36),
 TARGET_SOURCE_ID VARCHAR(36),
 MASTER_PROJECT_ID INTEGER,
 MASTER_REQUIREMENT_ID INTEGER,
 MASTER_REQUEST_ID INTEGER,
 MASTER_FILESTREAM_ID INTEGER,
 TARGET_PROJECT_ID INTEGER,
 TARGET_REQUIREMENT_ID INTEGER,
 TARGET_REQUEST_ID INTEGER,
 TARGET_FILESTREAM_ID INTEGER,
 MASTER_EXTERNAL_KEY1 INTEGER,
 MASTER_EXTERNAL_KEY2 VARCHAR(40),
 TARGET_EXTERNAL_KEY1 INTEGER,
 TARGET_EXTERNAL_KEY2 VARCHAR(40),
 MASTER_PROJECT_NAME VARCHAR(255),
 MASTER_REQUIREMENT_NAME VARCHAR(255),
 MASTER_REQUEST_NAME VARCHAR(255),
 MASTER_FILESTREAM_NAME VARCHAR(255),
 TARGET_PROJECT_NAME VARCHAR(255),
 TARGET_REQUIREMENT_NAME VARCHAR(255),
 TARGET_REQUEST_NAME VARCHAR(255),
 TARGET_FILESTREAM_NAME VARCHAR(255),
 REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL)
;

CREATE TABLE REORGANIZATION_LIST(
	STATS_ID			INTEGER NOT NULL,
	SCHEMA_NAME	VARCHAR(255),
	TABLE_NAME	VARCHAR(255),
	TABLE_TYPE	VARCHAR(255),
	ACTION			VARCHAR(255),
	COMMAND			VARCHAR(2048),
	ENABLED			INTEGER,
	ACTION_DATE DATE,
	ACTION_CODE VARCHAR(5),
	REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP
);
