#!/bin/ksh

# Auxiliary storage pool for the operational Data Store
# dDefault value of 1 is used
# if you need to change it specify a value 1-32 or the name of the pool

export ASPODS=1

# Auxiliary storage pool for the Data Mart
# Default value of 1 is used
# if you need to change it specify a value 1-32 or the name of the pool

export ASPDM=1

# Default Rational Reporting database ALIAS instance to use. 
# if a different value is required change the value of DBNAME
# Not accepting the default implies changes in the connection information
# defined on the Cognos BI server and Data Manager ETL

export DBNAME=RIDW

# Default account to use to execute the database installation.
# If a different value is required change the value of DBUSER
# Make sure to make the appropriate changes in the Data Manager credentials
# for the "Rational Data Warehouse" connection 

export DBUSER=db2admin

# Default account to use for the report executions.
# If a different value is required change the value of REP_USER.
# Not accepting the defaults implies that RIDW connection
# in the Cognos BI server will have to be changed

export REP_USER=RPTUSER

# Default start year from which to populate the 
# date dimension in the data mart.  If the default is not suitable 
# change the value of START_YEAR to any sensible value required.

export START_YEAR=2008

# Default end year up to which to populate the 
# date dimension in the data mart.  If the default is not suitable 
# change the value of END_YEAR to any sensible value required.
# END_YEAR must be greater than the value specified for START_YEAR

export END_YEAR=2012

# Do not change the values below

export NF_SCHEMA=RIODS

export RIASSET_SCHEMA=RIASSET

export RISCHK_SCHEMA=RISCHK

export STAR_SCHEMA=RIDW

export CALM_SCHEMA=RICALM
